/* $Id: PrintWriterTest.java,v 1.2 1999/10/14 23:48:49 akv Exp $
 */

package tests.dispatch;

import java.io.*;
import java.net.*;

import org.apache.tools.moo.TestableBase;
import org.apache.tools.moo.TestResult;
import org.apache.tools.moo.URLHelper;

public class PrintWriterTest extends TestableBase {

    public String getDescription() {
        return "PrintWriterTest Test";
    }

    public TestResult runTest() {
	TestResult testResult = new TestResult();
  	try {
            String sLoc = "/servlet/dispatch.PrintWriterTest1Servlet";

	    URL url = URLHelper.getURL(sLoc);
	    HttpURLConnection con = (HttpURLConnection)url.openConnection();
	    con.setFollowRedirects(false);
	    con.connect();

            InputStream in = con.getInputStream();
            BufferedReader br = new BufferedReader(new InputStreamReader(in));
            String s = null;

            s = br.readLine();

            if (! s.equals("PreInclude")) {
  	        testResult.setStatus(false);
  	        testResult.setMessage("didn't read expected PreInclude line");
  	        return testResult; 
            }

            s = br.readLine();
            if (s.indexOf("error: 500") > -1) {
                String line = null;

                while ((line = br.readLine()) != null) {
                    if (line.trim().length() == 0) {
                        break;
                    }
                }
            } else {
                testResult.setStatus(false);
                testResult.setMessage("IllegalStateException not thrown ");
                return testResult;
            }

            s = br.readLine();
            if (! s.equals("PostInclude")) {
  	        testResult.setStatus(false);
  	        testResult.setMessage("didn't read expected PostInclude line");
  	        return testResult; 
            }

            testResult.setStatus(true);
            return testResult;
  	} catch (Exception e) {
  	    testResult.setStatus(false);
  	    testResult.setMessage("Exception: " + e);
  	    return testResult; 
  	}
    }
}
